###############################################################################
# ChatBoard.pl                                                                #
###############################################################################
# YaBB: Yet another Bulletin Board                                            #
# Open-Source Community Software for Webmasters                               #
# Version:        YaBB 1 Gold - SP 1.3                                        #
# Released:       December 2001; Updated April 6, 2003                        #
# Distributed by: http://www.yabbforum.com                                    #
# =========================================================================== #
# Copyright (c) 2000-2003 YaBB (www.yabbforum.com) - All Rights Reserved.     #
# Software by: The YaBB Development Team                                      #
#              with assistance from the YaBB community.                       #
# Sponsored by: Xnull Internet Media, Inc. - http://www.ximinc.com            #
###############################################################################

$chatboardplver = "1 Gold - SP 1.3 - BETA 0.85";

	my $viewnum = $INFO{'num'};
	if( $viewnum =~ /\D/ ) { &fatal_error($txt{'337'}); }
	if( $currentboard eq '' ) { &fatal_error($txt{'1'}); }

	if (!-e("$boardsdir/$currentboard.chat") || $username eq 'Guest') { &fatal_error($txt{'1'}); }

sub ChatPage {
	# Check to make sure this thread isn't locked.
	($mnum,$msubthread,$mname,$memail,$mdate,$mreplies,$musername,$micon,$mstate) = split( /\|/, $yyThreadLine );

	fopen(FILE,"$datadir/$viewnum.chat");
	@chaton = <FILE>;
	fclose(FILE);
	
	for (my $i; $i <= @chaton; $i++) {
		$chatuser = $chaton[$i];
		chomp $chatuser;
		$chatuser =~ s/[\r\n]//g;

	    my ($chatname, $chattime) = split(/\|/, $chatuser);
	    
	    if ($chatname eq $settings[1]) {
	        $chattime = time;
		   	$chaton[$i] = "$settings[1]|" . time;

		   	$hasfound = 1;
		}
    }

    $ulink = "[url=$cgi&action=viewprofile&username=$username]$settings[1]" . "[/url]";

    if ($hasfound != 1) {
        push(@savethis, "$username|" . time);
        
      	&SysMessage("\[b]\[color=Green]$chattxt{'40a'}$ulink$chattxt{'40b'}$msubthread$chattxt{'40c'}\[/color]\[/b]");
	}

	fopen(FILE,">$datadir/$viewnum.chat");
	print FILE join("\n", @savethis);
	fclose(FILE);

	$yymain .= qq~
<html>
<head>
<title>
$chattxt{'20'}: $msubthread
</title>
</head>
<frameset framespacing="0" border="0" cols="80%,20%">~;

    $top = 90;
    $bottom = 10;

	if ($mstate == 0) {
	   	$yymain .= qq~
	<frameset rows="$top%,$bottom%" framespacing="0" border="0">
		<frame name="chat" src="$cgi&num=$viewnum&action=displaychat">
		<frame name="sendchat" src="$cgi&num=$viewnum&action=sendchat">
	</frameset>~;
	} else {
	    $yymain .= qq~
	<frame name="chat" src="$cgi&num=$viewnum&action=displaychat">~;
	}

	$yymain .= qq~
	<frame name="whosinchat" src="$cgi&num=$viewnum&action=whosinchat">
</frameset>
</html>~;

	&template(1);
}

sub GetNew {
	# Check to make sure this thread isn't locked.
	($mnum,$msubthread,$mname,$memail,$mdate,$mreplies,$musername,$micon,$mstate) = split( /\|/, $yyThreadLine );

	fopen(FILE,"$datadir/$viewnum.chat");
	@chaton = <FILE>;
	fclose(FILE);
	
	for (my $i; $i <= @chaton; $i++) {
		$chatuser = $chaton[$i];
		chomp $chatuser;
		$chatuser =~ s/[\r\n]//g;

	    my ($chatname, $chattime) = split(/\|/, $chatuser);

	    if ($chatname eq $username) {
		   	$chattime = time;
           	$chaton[$i] = "$username|" . time;
           	
           	$hasfound = 1;
     	}
    }
    
    if ($hasfound != 1) {
	   	$yymain .= qq~
<script language="JavaScript">
<!--
   parent.parent.window.close();
//-->
</script>
~;
  	}

	fopen(FILE,">$datadir/$viewnum.chat");
	print FILE join("\n",@savethis);
	fclose(FILE);

	$yymain .= qq~
<META HTTP-EQUIV=Refresh CONTENT="15; URL=$cgi&num=$viewnum&action=getnew" NAME="refresh">~;

	$dlp = &getlog($viewnum);
	$threaddate = stringtotime($mdate);
	if( $max_log_days_old && $dlp < $threaddate && &getlog("$currentboard--mark") < $threaddate ) {
		$yymain .= qq~
<script language="JavaScript">
<!--
   parent.location = parent.location;
//-->
</script>~;
	}

	&template(1);
}

sub SendChat {
	my( $email, $subject, $ns, $threadid, $notify, @memberlist, $a, $realname, $membername, $testname, @reserve, @reservecfg, $matchword, $matchcase, $matchuser, $matchname, $namecheck, $reserved, $reservecheck, $newthreadid, @messages, $mnum, $msub, $mname, $memail, $mdate, $mreplies, $musername, $micon, $mstate, $start, $pageindex, $tempname );

	# Check to make sure this thread isn't locked.
	($mnum,$msubthread,$mname,$memail,$mdate,$mreplies,$musername,$micon,$mstate) = split( /\|/, $yyThreadLine );

	if ($mstate == 1) {
	   	&fatal_error("$txt{'01'}");
	}

	if ($FORM{'message'} ne '') {
    	# Get the form values
		$name = $settings[1];
		$email = $settings[2];
		$subject = "";
		$message = $FORM{'message'};
	 	$icon = "xx";
		$ns = "";
		$threadid = $viewnum;
		$notify = "";
		
		if(!$settings[2]) {
			$check = ($FORM{'email'} eq '') ? 0 : $check;
			$check = ($FORM{'email'} !~ /[\w\-\.\+]+\@[\w\-\.\+]+\.(\w{2,4}$)/) ? 0 : $check;
			$check = (($FORM{'email'} =~ /(@.*@)|(\.\.)|(@\.)|(\.@)|(^\.)|(\.$)/) || ($FORM{'email'} !~ /^.+@\[?(\w|[-.])+\.[a-zA-Z]{2,4}|[0-9]{1,4}\]?$/)) ? 0 : $check;
		}

		if (!(length($message) > $MaxMessLen)) {
			$message =~ s/\cM//g;
			$message =~ s~\[([^\]]{0,30})\n([^\]]{0,30})\]~\[$1$2\]~g;
			$message =~ s~\[/([^\]]{0,30})\n([^\]]{0,30})\]~\[/$1$2\]~g;
			$message =~ s~(\w+://[^<>\s\n\"\]\[]+)\n([^<>\s\n\"\]\[]+)~$1\n$2~g;
			&ToHTML($message);
			$message =~ s~\t~ \&nbsp; \&nbsp; \&nbsp;~g;
			$message =~ s~\n~<br>~g;

			if($name && $email) {
				&ToHTML($name);
				$email =~ s/\|//g;
				&ToHTML($email);
				$tempname = $name;	# hold it temporarily so we can put the _'s back later
				$name =~ s/\_/ /g;
			}

			if(-e("$datadir/.txt")) { unlink("$datadir/.txt"); }

			++$mreplies;
			fopen(FILE, "+<$boardsdir/$currentboard.txt", 1) || &fatal_error("211 $txt{'106'}: $txt{'23'} $currentboard.txt");
			seek FILE, 0, 0;
			my @buffer = <FILE>;
			truncate FILE, 0;
			for ($a = 0; $a < @buffer; $a++) {
				if ( $buffer[$a] =~ m~\A$mnum\|~o ) { $buffer[$a] = ""; last; }
			}
			seek FILE, 0, 0;
			print FILE qq~$mnum|$msubthread|$mname|$memail|$date|$mreplies|$username|$micon|$mstate\n~;
			print FILE @buffer;
			fclose(FILE);
			fopen(FILE, ">>$datadir/$threadid.txt") || &fatal_error("212 $txt{'106'}: $txt{'23'} $threadid.txt");
			print FILE qq~$subject|$name|$email|$date|$username|$icon|0|$user_ip|$message|$ns|\n~;
			fclose(FILE);
		
			# The thread ID, regardless of whether it's a new thread or not.
			$thread = $threadid;
		
			# Update totals for this board.
			require "$sourcedir/Post.pl";
			&doaddition;
		}
	}

	$yymain .= qq~
<html>
<head>
<link rel="stylesheet" href="../../chat.css">
<script language="JavaScript">
<!--
   parent.chat.location = parent.chat.location;
//-->
</script>
</head>
<body class="chat">
<form name="send" action="$cgi&num=$viewnum&action=sendchat" method="POST">
<input type="hidden" name="threadid" value="$viewnum">
<table valign="center" width="100%">
<tr>
<td width="90%" colspan="1">
<font size="1">$txt{'72'}: </font><input type="text" name="message" size="75">
</td>
<td width="10%">
<input type="submit" name="submit" value="$chattxt{'30'}">
</td>
</tr>
</table>
</form>
<script language="JavaScript">
<!--
   document.send.message.focus();
//-->
</script>
</body>
</html>~;

	&template(1);
}

sub DisplayChat {
	my($buffer,$views,$lastposter,$moderators,$counter,$counterwords,$pageindex,$msubthread,$mnum,$mstate,$mdate,$msub,$mname,$memail,$mreplies,$musername,$micon,$noposting,$threadclass,$notify,$max,$start,$bgcolornum,$windowbg,$mattach,$mip,$mlm,$mlmb,$lastmodified,$postinfo,$star,$sendm,$topicdate);
	my(@userprofile,@messages,@bgcolors);

	# Mark current thread as read.
	($mnum,$tmpa,$tmpa,$tmpa,$mdate) = split(/\|/,$yyThreadLine);
	&dumplog($mnum,$date);

	&LoadCensorList;	# Load Censor List

	foreach (@censored) {
		($tmpa,$tmpb) = @{$_};
		$msubthread =~ s~\Q$tmpa\E~$tmpb~gi;
	}

	if(!$MenuType) { $sm = 1; }

	fopen(FILE,"$datadir/$viewnum.txt") || &fatal_error("104 $txt{'106'}: $txt{'23'} $viewnum.txt");

	for($counter = 0; $buffer = <FILE>; $counter++) {
		$messages[$counter] = $buffer;
	}
	fclose(FILE);

	$#messages = $counter - 1;
	$counter = 0;

	$refreshframe = qq~
<iframe src="$cgi&num=$viewnum&action=getnew" width="0" height="0"></iframe>~;

$yymain .= qq~
<html>
<head>
<link rel="stylesheet" href="../../chat.css">
$getnew
</head>
<body>
$refreshframe
<table cellpadding="0" cellspacing="0" border="0" width="100%" align="left" class="chat">~;

	# For each post in this thread:
	foreach (@messages) {
		undef $realgroup;
		chomp;
		($msub, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $postmessage, $ns, $mlm, $mlmb) = split(/[\|]/, $_);

		$msub ||= $txt{'24'};
		$messdate = &timeformat($mdate);

		# If the user isn't a guest, load his/her info.
		if($musername ne 'Guest' && ! $yyUDLoaded{$musername} && -e("$memberdir/$musername.dat") ) {
			&LoadUserDisplay($musername);	# If user is not in memory, s/he must be loaded.
		}
		$messagedate = stringtotime($mdate);
		$registrationdate = stringtotime($userprofile{$musername}->[14]);
		if($yyUDLoaded{$musername} && $messagedate > $registrationdate) {
			@userprofile = @{$userprofile{$musername}};
			$displayname = $userprofile[1];
			chomp $displayname;
			$usernamelink = qq~&lt;<a href="$cgi&action=viewprofile&username=$musername" target="_blank">$displayname</a>&gt;~;
		}
		else {
			$musername = "Guest";
			$usernamelink = qq~&lt;$mname&gt;~;
			$displayname = $mname;
		}
		# Censor the subject and message.
		foreach (@censored) {
			($tmpa,$tmpb) = @{$_};
			$postmessage =~ s~\Q$tmpa\E~$tmpb~gi;
			$msub =~ s~\Q$tmpa\E~$tmpb~gi;
		}
		# Run UBBC interpreter on the message.
		$message = $postmessage; # put the message back into the proper variable to do ubbc on it
		&wrap;
		if($enable_ubbc) { if(!$yyYaBBCloaded) { require "$sourcedir/YaBBC.pl"; } &DoUBBC; }
		&wrap2;
		$profbutton = $profilebutton && $musername ne 'Guest' ? qq~<a href="$scripturl?action=viewprofile;username=$useraccount{$musername}">$img{'viewprofile_sm'}</a>$menusep~ : '';
		if($counter != 0) { $counterwords = "$txt{'146'} #$counter"; }
		else { $counterwords = ""; }
		# Print the post and user info for the poster.
		($dummy, $dummy, $mdate) = split(/ /, $mdate);
		$yymain .= qq~
  <tr>
    <td width="12%">
        [$mdate]
    </td>
    <td width="10%">
        $usernamelink
    </td>
    <td width="78%">
        $message
    </td>
  </tr>~;
		$counter++;
	}
	$yymain .= qq~
</table> 
<script language="JavaScript">
<!--
   window.scrollBy(0,65535);
//-->
</script>
</body>
</html>~;

	&template(1);
	exit;
}

sub WhosInChat {
	# Check to make sure this thread isn't locked.
	($mnum,$msubthread,$mname,$memail,$mdate,$mreplies,$musername,$micon,$mstate) = split( /\|/, $yyThreadLine );

	$yymain .= qq~
<html>
<head>
<META HTTP-EQUIV=Refresh CONTENT="61; URL=$cgi&num=$viewnum&action=whosinchat" name="refresh">
</head>
<link rel="stylesheet" href="../../chat.css">
<body class="chat">~;

	fopen(FILE,"$datadir/$viewnum.chat");
	@chaton = <FILE>;
	fclose(FILE);

	for (my $i; $i <= @chaton; $i++) {
		$chatuser = $chaton[$i];
		chomp $chatuser;
		$chatuser =~ s/[\r\n]//g;

	    my ($chatname, $chattime) = split(/\|/, $chatuser);

	    if ($chatname eq $username) {
		   	$chattime = time;
           	$chaton[$i] = "$username|" . time;

           	$hasfound = 1;
     	}

     	if ((($chattime + 90) > time) && $chatname ne '') {
		   	push(@savethis,"$chatname|$chattime");
			if(!$yyUDLoaded{$chatname} && -e("$memberdir/$chatname.dat") ) {
				&LoadUserDisplay($chatname);	# If user is not in memory, s/he must be loaded.
			}
			if($yyUDLoaded{$chatname}) {
				@userprofile = @{$userprofile{$chatname}};
				$displayname = $userprofile[1];
				chomp $displayname;
				$usernamelink = qq~<a href="$cgi&action=viewprofile&username=$chatname" target="_blank"><b>$displayname</b></a>~;
			} else {
				$usernamelink = qq~<b>$chatname</b>~;
			}

			$yymain .= qq~$usernamelink<br>~;
		} elsif (($chattime + 90) < time && $chatname ne '') {
			if(!$yyUDLoaded{$chatname} && -e("$memberdir/$chatname.dat") ) {
				&LoadUserDisplay($chatname);	# If user is not in memory, s/he must be loaded.
			}
			if($yyUDLoaded{$chatname}) {
				@userprofile = @{$userprofile{$chatname}};
				$displayname = $userprofile[1];
				chomp $displayname;
				$usernamelink = "[url=$cgi&action=viewprofile&username=$chatname]$displayname" . "[/url]";
			} else {
				$usernamelink = "$chatname";
			}

		    &SysMessage("[b][color=Blue]$chattxt{'41a'}$usernamelink$chattxt{'41b'}$msubthread$chattxt{'41d'}" . "[/color]" . "[/b]");
		}
    }
    
    if ($hasfound != 1) {
	   	$yymain .= qq~
<script language="JavaScript">
<!--
   parent.parent.window.close();
//-->
</script>
~;
  	}

	fopen(FILE,">$datadir/$viewnum.chat");
	print FILE join("\n", @savethis);
	fclose(FILE);

    $yymain .= qq~
<br>
<a href="$cgi&num=$viewnum&action=leavechat" target="_self"><b>$chattxt{'31'}</b></a>
$refresh
</body>
</html>~;

	&template(1);
}

sub LeaveChat {
	# Check to make sure this thread isn't locked.
	($mnum,$msubthread,$mname,$memail,$mdate,$mreplies,$musername,$micon,$mstate) = split( /\|/, $yyThreadLine );

	$yymain .= qq~
<script language="JavaScript">
<!--
   parent.window.close();
//-->
</script>
~;

	fopen(FILE,"$datadir/$viewnum.chat");
	@chaton = <FILE>;
	fclose(FILE);

	for (my $i; $i <= @chaton; $i++) {
		$chatuser = $chaton[$i];
		chomp $chatuser;
		$chatuser =~ s/[\r\n]//g;

	    my ($chatname, $chattime) = split(/\|/, $chatuser);

     	if ($chatname ne $username) {
		   	push(@savethis,"$chatname|$chattime");
		}
    }

	fopen(FILE,">$datadir/$viewnum.chat");
	print FILE join("\n", @savethis);
	fclose(FILE);
	
	if(!$yyUDLoaded{$username} && -e("$memberdir/$username.dat") ) {
		&LoadUserDisplay($username);	# If user is not in memory, s/he must be loaded.
	}
	if($yyUDLoaded{$username}) {
		@userprofile = @{$userprofile{$username}};
		$displayname = $userprofile[1];
		chomp $displayname;
		$usernamelink = "[url=$cgi&action=viewprofile&username=$username]$displayname" . "[/url]";
	} else {
		$usernamelink = "$username";
	}
	
	&SysMessage("\[b]\[color=Red]$chattxt{'41a'}$usernamelink$chattxt{'41b'}$msubthread$chattxt{'41c'}\[/color]\[/b]");

	&template(1);
}

sub SysMessage {
	my $message = $_[0];

	my( $email, $subject, $ns, $threadid, $notify, @memberlist, $a, $realname, $membername, $testname, @reserve, @reservecfg, $matchword, $matchcase, $matchuser, $matchname, $namecheck, $reserved, $reservecheck, $newthreadid, @messages, $mnum, $msub, $mname, $memail, $mdate, $mreplies, $musername, $micon, $mstate, $start, $pageindex, $tempname );

	# Check to make sure this thread isn't locked.
	($mnum,$msubthread,$mname,$memail,$mdate,$mreplies,$musername,$micon,$mstate) = split( /\|/, $yyThreadLine );

	if ($mstate == 0) {
    	# Get the form values
		$email = "";
		$subject = "";
	 	$icon = "xx";
		$ns = "";
		$threadid = $viewnum;
		$notify = "";
		
		$check = 1;

		$message =~ s/\cM//g;
		$message =~ s~\[([^\]]{0,30})\n([^\]]{0,30})\]~\[$1$2\]~g;
		$message =~ s~\[/([^\]]{0,30})\n([^\]]{0,30})\]~\[/$1$2\]~g;
		$message =~ s~(\w+://[^<>\s\n\"\]\[]+)\n([^<>\s\n\"\]\[]+)~$1\n$2~g;
		&ToHTML($message);
		$message =~ s~\t~ \&nbsp; \&nbsp; \&nbsp;~g;
		$message =~ s~\n~<br>~g;

		if(-e("$datadir/.txt")) { unlink("$datadir/.txt"); }
	
		++$mreplies;
		fopen(FILE, "+<$boardsdir/$currentboard.txt", 1) || &fatal_error("211 $txt{'106'}: $txt{'23'} $currentboard.txt");
		seek FILE, 0, 0;
		my @buffer = <FILE>;
		truncate FILE, 0;
		for ($a = 0; $a < @buffer; $a++) {
			if ( $buffer[$a] =~ m~\A$mnum\|~o ) { $buffer[$a] = ""; last; }
		}
		seek FILE, 0, 0;
		print FILE qq~$mnum|$msubthread|$mname|$memail|$date|$mreplies|ChatSys|$micon|$mstate\n~;
		print FILE @buffer;
		fclose(FILE);
		fopen(FILE, ">>$datadir/$threadid.txt") || &fatal_error("212 $txt{'106'}: $txt{'23'} $threadid.txt");
		print FILE qq~$subject|ChatSys||$date|ChatSys|$icon|0|$user_ip|$message|$ns|\n~;
		fclose(FILE);
	}
	
	$refresh = qq~
<script language="JavaScript">
<!--
   parent.chat.location = parent.chat.location;
//-->
</script>~;
}

1;
