<id>
YaBB Chat Boards SP 1.3.1 - BETA 0.85
</id>

<version>
BETA 0.85
</version>

<mod info>
This Mods may let you set some boards as "Chat Boards" in your Manage Boards page. In Chat Boards, there is a link after each Thread which opens the same Thread with a IRC-like chat style in a new window. You can reply to the thread quickly just by typing a message into the message field at the bottom of the window. In the right, there is a list showing all users who currently have opened this window. The chat window will be refreshed every 15 seconds. There are no Op functions available for the chat currently but I'm going to add some like kicking users and setting other Ops.

Guests can't use the chat features!

To install, use the following steps:

1. Install this Mod.
2. Upload all modified files and the ChatBoard.pl to your YaBB.
3. Upload the chat.css to the folder which is lying two levels over the main YaBB folder.

Users post counters will never increase when they post in a chat window.

You should register an additional user called "ChanServ" and give it a special rank because it will tell of members leaving and entering, else people can do rubbish with this.
</mod info>

<author>
Daniel Alm aka MrMage (Muskelkater2@gmx.de)
</author>

<homepage>

</homepage>

<edit file>
english.lng
</edit file>

<search for>
$txt{'749'} = "The 'number of posts' box can only contain digits.";
</search for>

<add after>
### CHAT BOARD START ###
$chattxt{'01'} = "Chat Board?";
$chattxt{'10'} = "Open Chat";
$chattxt{'20'} = "Chat";
$chattxt{'30'} = "Send";
$chattxt{'31'} = "Leave Chat";
$chattxt{'40a'} = "The user ";
$chattxt{'40b'} = " has joined ";
$chattxt{'40c'} = ".";
$chattxt{'41a'} = "The user ";
$chattxt{'41b'} = " has left ";
$chattxt{'41c'} = ".";
$chattxt{'41d'} = " due to timeout.";
$chattxt{'42a'} = "The user ";
$chattxt{'42b'} = " has changed his/her name to ";
$chattxt{'42c'} = ".";
### CHAT BOARD END ###

</add after>

<edit file>
Sources/Display.pl
</edit file>

<search for>
    <table cellpadding="3" cellspacing="1" border="0" width="100%">
      <tr>
        <td valign="middle" align="left" width="20%" bgcolor="$color{'titlebg'}" class="titlebg">
        <font size=2 class="text1" color="$color{'titletext'}">&nbsp;<img src="$imagesdir/$threadclass.gif" alt="">
        &nbsp;<b>$txt{'29'}</b></font></td>
        <td valign="middle" align="left" bgcolor="$color{'titlebg'}" class="titlebg" width="80%">
        <font size=2 class="text1" color="$color{'titletext'}"><b>&nbsp;$txt{'118'}: $msubthread</b> &nbsp;($txt{'641'} $views $txt{'642'})</font></td>
      </tr>
    </table>
</search for>

<replace>
~;

	if (-e("$boardsdir/$currentboard.chat") && $username ne 'Guest') {
	   	$openchat = qq~
<b>(<a href="#" onclick="window.open('$cgi&action=chatpage&num=$viewnum','','scrollbars=no, width=800px, height=600px');"><b>$chattxt{'10'}</b></a>)</b>~;
   	} else { $openchat = ""; }

$yymain .= qq~
    <table cellpadding="3" cellspacing="1" border="0" width="100%">
      <tr>
        <td valign="middle" align="left" width="20%" bgcolor="$color{'titlebg'}" class="titlebg">
        <font size=2 class="text1" color="$color{'titletext'}">&nbsp;<img src="$imagesdir/$threadclass.gif" alt="">
        &nbsp;<b>$txt{'29'}</b></font></td>
        <td valign="middle" align="left" bgcolor="$color{'titlebg'}" class="titlebg" width="80%">
        <font size=2 class="text1" color="$color{'titletext'}"><b>&nbsp;$txt{'118'}: $msubthread</b> &nbsp;($txt{'641'} $views $txt{'642'})$openchat</font></td>
      </tr>
    </table>
</replace>

<edit file>
Sources/Subs.pl
</edit file>

<search for>
sub template {
</search for>

<add after>
	my $ischat = $_[0];

</add after>

<search for>
	fopen(TEMPLATE,"template.html") || die("$txt{'23'}: template.html");
	@yytemplate = <TEMPLATE>;
	fclose(TEMPLATE);
</search for>

<replace>
	if ($ischat != 1) {
		fopen(TEMPLATE,"template.html") || die("$txt{'23'}: template.html");
		@yytemplate = <TEMPLATE>;
		fclose(TEMPLATE);
	} else {
	    @yytemplate = ('<yabb main>');
	}
</replace>

<search for>
	if($yycopyin == 0) {
</search for>

<replace>
	if($yycopyin == 0 && $ischat != 1) {
</replace>

<edit file>
Sources/MessageIndex.pl
</edit file>

<search for>
		# Print the thread info.
</search for>

<add before>
		if (-e("$boardsdir/$currentboard.chat") && $username ne 'Guest') {
		   	$openchat = qq~
<b>(<a href="#" onclick="window.open('$scripturl?board=$currentboard&action=chatpage&num=$mnum','','scrollbars=no, width=800px, height=600px');"><b>$chattxt{'10'}</b></a>)</b>~;
   		} else { $openchat = ""; }
</add before>

<search for>
        <td class="windowbg" valign="middle" width="44%" bgcolor="$color{'windowbg'}"><font size="2">$new <a href="$cgi;action=display;num=$mnum"><b>$msub</b></a> $pages</font></td>
</search for>

<replace>
        <td class="windowbg" valign="middle" width="44%" bgcolor="$color{'windowbg'}"><font size="2">$new <a href="$cgi;action=display;num=$mnum"><b>$msub</b></a> $pages$openchat</font></td>
</replace>

<edit file>
Sources/SubList.pl
</edit file>

<search for>
'login',"LogInOut.pl&Login",
</search for>

<add before>
'chatpage',"ChatBoard.pl&ChatPage",
'displaychat',"ChatBoard.pl&DisplayChat",
'whosinchat',"ChatBoard.pl&WhosInChat",
'sendchat',"ChatBoard.pl&SendChat",
'leavechat',"ChatBoard.pl&LeaveChat",
'getnew',"ChatBoard.pl&GetNew",
</add before>

<edit file>
Sources/RemoveThread.pl
</edit file>

<search for>
	unlink("$datadir/$thread.txt");
</search for>

<add after>
	unlink("$datadir/$thread.chat");
</add after>

<edit file>
Sources/ManageBoards.pl
</edit file>

<search for>
			unlink("$datadir/$id\.txt");
</search for>

<add after>
			unlink("$datadir/$id\.chat");
</add after>

<search for>
				$moderator = "$modprop[1]";
</search for>

<add before>
				$chaton = -e("$boardsdir/$curboard.chat") ? ' checked' : '';
</add before>

<search for>
        <input type="text" name="boardname" value="$curboardname" size="30"><br>
</search for>

<replace>
        <input type="text" name="boardname" value="$curboardname" size="30"><br><font size="1"><input type="checkbox" name="chat" $chaton>$chattxt{'01'}</font><br>
</replace>

<search for>
	if($FORM{'moda'} eq "$txt{'17'}") {
</search for>

<add after>
		if ($FORM{'chat'} eq 'on') {
		    fopen(FILE,">$boardsdir/$FORM{'id'}.chat");
		    fclose(FILE);
		} else {
		    unlink("$boardsdir/$FORM{'id'}.chat");
		}
</add after>

<search for>
		unlink("$boardsdir/$curboard.ctb");
</search for>

<add after>
		unlink("$boardsdir/$curboard.chat");
</add after>

<edit file>
Sources/ModifyMessage.pl
</edit file>

<search for>
			unlink("$datadir/$tnum.txt");
</search for>

<add after>
			unlink("$datadir/$tnum.chat");
</add after>

<edit file>
Sources/RemoveOldThreads.pl
</edit file>

<search for>
					unlink("$datadir/$num.txt");
</search for>

<add after>
					unlink("$datadir/$num.chat");
</add after>

<edit file>
Sources/Post.pl
</edit file>

<search for>
sub doaddition {
</search for>

<add after>
	my $uname = $_[0];
</add after>

<search for>
	&BoardCountSet( $currentboard, $threadcount, $messagecount, $date, $myname );
</search for>

<add before>
	$myname = ($uname eq '') ? $myname : $uname;
</add before>